diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index 4f2063f..6f62c5c 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -10,63 +10,63 @@ include_HEADERS = \
 
 odpincludedir= $(includedir)/odp
 odpinclude_HEADERS = \
-		  $(top_srcdir)/platform/linux-generic/include/odp/align.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/atomic.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/barrier.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/buffer.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/byteorder.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/classification.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/compiler.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/config.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/cpu.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/cpumask.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/crypto.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/debug.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/errno.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/event.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/hints.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/init.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/packet_flags.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/packet.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/packet_io.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/pool.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/queue.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/random.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/rwlock.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/schedule.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/shared_memory.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/spinlock.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/std_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/sync.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/system_info.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/thread.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/ticketlock.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/time.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/timer.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/version.h
+		  $(srcdir)/include/odp/align.h \
+		  $(srcdir)/include/odp/atomic.h \
+		  $(srcdir)/include/odp/barrier.h \
+		  $(srcdir)/include/odp/buffer.h \
+		  $(srcdir)/include/odp/byteorder.h \
+		  $(srcdir)/include/odp/classification.h \
+		  $(srcdir)/include/odp/compiler.h \
+		  $(srcdir)/include/odp/config.h \
+		  $(srcdir)/include/odp/cpu.h \
+		  $(srcdir)/include/odp/cpumask.h \
+		  $(srcdir)/include/odp/crypto.h \
+		  $(srcdir)/include/odp/debug.h \
+		  $(srcdir)/include/odp/errno.h \
+		  $(srcdir)/include/odp/event.h \
+		  $(srcdir)/include/odp/hints.h \
+		  $(srcdir)/include/odp/init.h \
+		  $(srcdir)/include/odp/packet_flags.h \
+		  $(srcdir)/include/odp/packet.h \
+		  $(srcdir)/include/odp/packet_io.h \
+		  $(srcdir)/include/odp/pool.h \
+		  $(srcdir)/include/odp/queue.h \
+		  $(srcdir)/include/odp/random.h \
+		  $(srcdir)/include/odp/rwlock.h \
+		  $(srcdir)/include/odp/schedule.h \
+		  $(srcdir)/include/odp/shared_memory.h \
+		  $(srcdir)/include/odp/spinlock.h \
+		  $(srcdir)/include/odp/std_types.h \
+		  $(srcdir)/include/odp/sync.h \
+		  $(srcdir)/include/odp/system_info.h \
+		  $(srcdir)/include/odp/thread.h \
+		  $(srcdir)/include/odp/ticketlock.h \
+		  $(srcdir)/include/odp/time.h \
+		  $(srcdir)/include/odp/timer.h \
+		  $(srcdir)/include/odp/version.h
 
 odpplatincludedir= $(includedir)/odp/plat
 odpplatinclude_HEADERS = \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/atomic_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/barrier_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/buffer_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/byteorder_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/classification_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/cpumask_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/crypto_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/event_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/packet_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/packet_io_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/pool_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/queue_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/rwlock_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/schedule_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/shared_memory_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/spinlock_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/strong_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/ticketlock_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/timer_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/odp/plat/version_types.h
+		  $(srcdir)/include/odp/plat/atomic_types.h \
+		  $(srcdir)/include/odp/plat/barrier_types.h \
+		  $(srcdir)/include/odp/plat/buffer_types.h \
+		  $(srcdir)/include/odp/plat/byteorder_types.h \
+		  $(srcdir)/include/odp/plat/classification_types.h \
+		  $(srcdir)/include/odp/plat/cpumask_types.h \
+		  $(srcdir)/include/odp/plat/crypto_types.h \
+		  $(srcdir)/include/odp/plat/event_types.h \
+		  $(srcdir)/include/odp/plat/packet_types.h \
+		  $(srcdir)/include/odp/plat/packet_io_types.h \
+		  $(srcdir)/include/odp/plat/pool_types.h \
+		  $(srcdir)/include/odp/plat/queue_types.h \
+		  $(srcdir)/include/odp/plat/rwlock_types.h \
+		  $(srcdir)/include/odp/plat/schedule_types.h \
+		  $(srcdir)/include/odp/plat/shared_memory_types.h \
+		  $(srcdir)/include/odp/plat/spinlock_types.h \
+		  $(srcdir)/include/odp/plat/strong_types.h \
+		  $(srcdir)/include/odp/plat/ticketlock_types.h \
+		  $(srcdir)/include/odp/plat/timer_types.h \
+		  $(srcdir)/include/odp/plat/version_types.h
 
 odpapiincludedir= $(includedir)/odp/api
 odpapiinclude_HEADERS = \
@@ -106,26 +106,26 @@ odpapiinclude_HEADERS = \
 		  $(top_srcdir)/include/odp/api/version.h
 
 noinst_HEADERS = \
-		  ${top_srcdir}/platform/linux-generic/include/odp_align_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_atomic_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_buffer_inlines.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_buffer_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_classification_datamodel.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_classification_inlines.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_classification_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_crypto_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_debug_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_packet_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_packet_io_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_packet_io_queue.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_packet_socket.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_pool_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_queue_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_schedule_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_spin_internal.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_timer_internal.h \
-		  ${top_srcdir}/platform/linux-generic/Makefile.inc
+		  ${srcdir}/include/odp_align_internal.h \
+		  ${srcdir}/include/odp_atomic_internal.h \
+		  ${srcdir}/include/odp_buffer_inlines.h \
+		  ${srcdir}/include/odp_buffer_internal.h \
+		  ${srcdir}/include/odp_classification_datamodel.h \
+		  ${srcdir}/include/odp_classification_inlines.h \
+		  ${srcdir}/include/odp_classification_internal.h \
+		  ${srcdir}/include/odp_crypto_internal.h \
+		  ${srcdir}/include/odp_debug_internal.h \
+		  ${srcdir}/include/odp_internal.h \
+		  ${srcdir}/include/odp_packet_internal.h \
+		  ${srcdir}/include/odp_packet_io_internal.h \
+		  ${srcdir}/include/odp_packet_io_queue.h \
+		  ${srcdir}/include/odp_packet_socket.h \
+		  ${srcdir}/include/odp_pool_internal.h \
+		  ${srcdir}/include/odp_queue_internal.h \
+		  ${srcdir}/include/odp_schedule_internal.h \
+		  ${srcdir}/include/odp_spin_internal.h \
+		  ${srcdir}/include/odp_timer_internal.h \
+		  ${srcdir}/Makefile.inc
 
 subdirheadersdir = $(includedir)/odp/helper
 subdirheaders_HEADERS = \