diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index f2c081a..a2da4ed 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -70,6 +70,7 @@ odpplatinclude_HEADERS = \
 		  $(srcdir)/include/odp/plat/strong_types.h \
 		  $(srcdir)/include/odp/plat/thrmask_types.h \
 		  $(srcdir)/include/odp/plat/ticketlock_types.h \
+		  $(srcdir)/include/odp/plat/time_types.h \
 		  $(srcdir)/include/odp/plat/timer_types.h \
 		  $(srcdir)/include/odp/plat/version_types.h
 
diff --git a/platform/linux-generic/arch/linux/odp_time_cycles.c b/platform/linux-generic/arch/linux/odp_time_cycles.c
index 4dc0764..70d611d 100644
--- a/platform/linux-generic/arch/linux/odp_time_cycles.c
+++ b/platform/linux-generic/arch/linux/odp_time_cycles.c
@@ -16,7 +16,7 @@
 
 #define GIGA 1000000000
 
-uint64_t odp_time_cycles(void)
+odp_time_t odp_time(void)
 {
 	struct timespec time;
 	uint64_t sec, ns, hz, cycles;
@@ -34,5 +34,5 @@ uint64_t odp_time_cycles(void)
 	cycles  = sec * hz;
 	cycles += (ns * hz) / GIGA;
 
-	return cycles;
+	return (odp_time_t)cycles;
 }
diff --git a/platform/linux-generic/arch/mips64/odp_time_cycles.c b/platform/linux-generic/arch/mips64/odp_time_cycles.c
index 4fb790b..0bbd18a 100644
--- a/platform/linux-generic/arch/mips64/odp_time_cycles.c
+++ b/platform/linux-generic/arch/mips64/odp_time_cycles.c
@@ -8,7 +8,7 @@
 #include <odp/hints.h>
 #include <odp/system_info.h>
 
-uint64_t odp_time_cycles(void)
+odp_time_t odp_time(void)
 {
 	#define CVMX_TMP_STR(x) CVMX_TMP_STR2(x)
 	#define CVMX_TMP_STR2(x) #x
@@ -17,5 +17,5 @@ uint64_t odp_time_cycles(void)
 	__asm__ __volatile__ ("rdhwr %[rt],$" CVMX_TMP_STR(31) :
 			   [rt] "=d" (cycle) : : "memory");
 
-	return cycle;
+	return (odp_time_t)cycle;
 }
diff --git a/platform/linux-generic/arch/x86/odp_time_cycles.c b/platform/linux-generic/arch/x86/odp_time_cycles.c
index a111561..78651c4 100644
--- a/platform/linux-generic/arch/x86/odp_time_cycles.c
+++ b/platform/linux-generic/arch/x86/odp_time_cycles.c
@@ -5,7 +5,7 @@
  */
 #include <odp/time.h>
 
-uint64_t odp_time_cycles(void)
+odp_time_t odp_time(void)
 {
 	union {
 		uint64_t tsc_64;
@@ -19,5 +19,5 @@ uint64_t odp_time_cycles(void)
 		     "=a" (tsc.lo_32),
 		     "=d" (tsc.hi_32) : : "memory");
 
-	return tsc.tsc_64;
+	return (odp_time_t)tsc.tsc_64;
 }
diff --git a/platform/linux-generic/include/odp/plat/time_types.h b/platform/linux-generic/include/odp/plat/time_types.h
new file mode 100644
index 0000000..9ba1508
--- /dev/null
+++ b/platform/linux-generic/include/odp/plat/time_types.h
@@ -0,0 +1,36 @@
+/* Copyright (c) 2015, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+/**
+ * @file
+ *
+ * ODP time service
+ */
+
+#ifndef ODP_TIME_TYPES_H_
+#define ODP_TIME_TYPES_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/** @addtogroup odp_time
+ *  @{
+ **/
+
+typedef uint64_t odp_time_t;
+
+#define ODP_TIME_NULL ((odp_time_t)0)
+
+/**
+ * @}
+ */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff --git a/platform/linux-generic/include/odp/time.h b/platform/linux-generic/include/odp/time.h
index 3a3960b..44e0d0d 100644
--- a/platform/linux-generic/include/odp/time.h
+++ b/platform/linux-generic/include/odp/time.h
@@ -21,6 +21,7 @@ extern "C" {
 
 
 
+#include <odp/plat/time_types.h>
 #include <odp/api/time.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/odp_schedule.c b/platform/linux-generic/odp_schedule.c
index 5d32c81..fd7c263 100644
--- a/platform/linux-generic/odp_schedule.c
+++ b/platform/linux-generic/odp_schedule.c
@@ -510,10 +510,10 @@ static int schedule_loop(odp_queue_t *out_queue, uint64_t wait,
 			 odp_event_t out_ev[],
 			 unsigned int max_num, unsigned int max_deq)
 {
-	uint64_t start_cycle, cycle, diff;
+	odp_time_t start_time, time, diff;
 	int ret;
 
-	start_cycle = 0;
+	start_time = ODP_TIME_NULL;
 
 	while (1) {
 		ret = schedule(out_queue, out_ev, max_num, max_deq);
@@ -527,15 +527,15 @@ static int schedule_loop(odp_queue_t *out_queue, uint64_t wait,
 		if (wait == ODP_SCHED_NO_WAIT)
 			break;
 
-		if (start_cycle == 0) {
-			start_cycle = odp_time_cycles();
+		if (!odp_time_cmp(start_time, ODP_TIME_NULL)) {
+			start_time = odp_time();
 			continue;
 		}
 
-		cycle = odp_time_cycles();
-		diff  = odp_time_diff_cycles(start_cycle, cycle);
+		time = odp_time();
+		diff  = odp_time_diff(start_time, time);
 
-		if (wait < diff)
+		if (odp_time_cmp(diff, wait) > 0)
 			break;
 	}
 
@@ -579,7 +579,7 @@ uint64_t odp_schedule_wait_time(uint64_t ns)
 	if (ns <= ODP_SCHED_NO_WAIT)
 		ns = ODP_SCHED_NO_WAIT + 1;
 
-	return odp_time_ns_to_cycles(ns);
+	return (uint64_t)odp_time_from_ns(ns);
 }
 
 
diff --git a/platform/linux-generic/odp_time.c b/platform/linux-generic/odp_time.c
index a007d69..6b1a6ff 100644
--- a/platform/linux-generic/odp_time.c
+++ b/platform/linux-generic/odp_time.c
@@ -12,31 +12,74 @@
 
 #define GIGA 1000000000
 
-uint64_t odp_time_diff_cycles(uint64_t t1, uint64_t t2)
+static inline
+uint64_t time_to_tick(odp_time_t time)
 {
-	if (odp_likely(t2 >= t1))
-		return t2 - t1;
+	return (uint64_t)time;
+}
+
+static inline
+odp_time_t tick_to_time(uint64_t tick)
+{
+	return (odp_time_t)tick;
+}
+
+odp_time_t odp_time_diff(odp_time_t t1, odp_time_t t2)
+{
+	uint64_t tick1 = time_to_tick(t1);
+	uint64_t tick2 = time_to_tick(t2);
+
+	if (odp_likely(tick2 >= tick1))
+		return tick_to_time(tick2 - tick1);
 
-	return t2 + (UINT64_MAX - t1);
+	return tick_to_time(tick2 + (UINT64_MAX - tick1));
 }
 
-uint64_t odp_time_cycles_to_ns(uint64_t cycles)
+uint64_t odp_time_to_ns(odp_time_t time)
 {
 	uint64_t hz = odp_sys_cpu_hz();
+	uint64_t tick = time_to_tick(time);
 
-	if (cycles > (UINT64_MAX / GIGA))
-		return (cycles/hz)*GIGA;
+	if (tick > (UINT64_MAX / GIGA))
+		return (tick / hz) * GIGA;
 
-	return (cycles*GIGA)/hz;
+	return (tick * GIGA) / hz;
 }
 
 
-uint64_t odp_time_ns_to_cycles(uint64_t ns)
+odp_time_t odp_time_from_ns(uint64_t ns)
 {
 	uint64_t hz = odp_sys_cpu_hz();
 
 	if (ns > (UINT64_MAX / hz))
-		return (ns/GIGA)*hz;
+		return tick_to_time((ns / GIGA) * hz);
+
+	return tick_to_time((ns * hz) / GIGA);
+}
+
+int odp_time_cmp(odp_time_t t1, odp_time_t t2)
+{
+	uint64_t tick1 = time_to_tick(t1);
+	uint64_t tick2 = time_to_tick(t2);
+
+	if (tick1 < tick2)
+		return 1;
+
+	if (tick1 > tick2)
+		return -1;
+
+	return 0;
+}
 
-	return (ns*hz)/GIGA;
+odp_time_t odp_time_sum(odp_time_t t1, odp_time_t t2)
+{
+	uint64_t tick1 = time_to_tick(t1);
+	uint64_t tick2 = time_to_tick(t2);
+
+	return tick_to_time(tick1 + tick2);
+}
+
+uint64_t odp_time_to_u64(odp_time_t hdl)
+{
+	return time_to_tick(hdl);
 }